<!--
//	Zoom Version 1.7.0
//	A fast custom search engine
//	Copyright (C) Wrensoft 2000, 2001
//	www.wrensoft.com
//	DonationWare
//	Use it for free, if you would like to support ongoing development
//	send us a donation. See our web page for details. www.wrensoft.com
//
//	@@@	JScript Beta
//	Zoom	Translated - Jun 2002
//	The original PHP Script was translated to Jscript in order to be 
//	used as an Offline/Online client_side Search Engine.
//
//	Changes to the original Script are documented between ********
//	To see small changes between lines, search @@@ 

//**************************************************************
var $debugging = 0;					// 1 Don't use print (for full debugging)
									// 0 Normal print (extra-limited debugging)
//**************************************************************

//	Settings
var $ZoomInfo		= 1;		//0 = Don't display Zoom info line at bottom of search
								//1 = Display Zoom info line at bottom of search
var $OutputStyle	= 1;		//0 = Basic Style, Page Title, Score and URL
								//1 = Descriptive Stlye, Match number, Page Title, Page description, Score and URL
var $JoinType		= 0;		//0 = Search terms are combined with a boolean OR. i.e. Any words must appear on a page
								//1 = Search terms are combined with a boolean AND. i.e. All words must appear on a page
var	$Logging		= 0;		//0 = No logging of words that a user enter.
								//1 = Words are logged to a file for later analysis. (See documentation for file permission issues)
var $LogFileName	= "h:\\sluz\\logs\\searchwords.log";	//Path and File name of search word log file
var $MaxKeyWordLineLen = 2000;	//Maximum line length of a single line in the KeyWords file.
								//Increase, if required, so that   MaxKeyWordLineLen >= Number of web pages in site * 6
var $WordSplit		= 1;		//0 = Only split input search phrase into words when a Space character is found
								//1 = Split input search phrase at Space ' ', UnderScore '_' , Dash '-' and Plus '+' characters
							
							
//******************************************************************	
//						NEW DEFINITIONS

// Constants for File Objects Operations								
var ForReading = 1, ForWriting = 2, ForAppending = 8;
var TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0;

// Instalation Path ----> TO BE READ AT EXECUTION (OR LOAD) TIME
var $ProgramPath = "h:\\Urad\\Intranet";

//						END NEW DEFINITIONS
//*******************************************************************


//FUNCTION: SortCompare
//Compare the two values, used for sorting output results
//Results that match all search terms are put first. Then results with highest score
function SortCompare ($a, $b) {
	if ($a[2] < $b[2])
		return 1;
	else
	if ($a[2] > $b[2])
		return -1;
	else {
		if ($a[1] < $b[1])
			return 1;
		else
		if ($a[1] > $b[1])
			return -1;
		else
			return 0;
	}
} // end SortCompare 

//********************************************************************
//						PHP SIMULATION

// Implements a function to replace the PHP "file" function
function file (filename) {
// Fills an array with the all the lines of a text file
// One line on each array entry
	var TheArray = new Array(); // 0 based
    var FSystem, TheFile, TheStream;
	var i;
	
	filename = $ProgramPath + "\\" + filename;
	// Assign and open file
    FSystem = new ActiveXObject("Scripting.FileSystemObject");
    TheFile = FSystem.GetFile(filename);
    TheStream = TheFile.OpenAsTextStream(ForReading,TristateUseDefault);
    i = 0;
    while (!TheStream.AtEndOfStream)
		TheArray [i++] = TheStream.ReadLine();
	TheStream.Close();
	return (TheArray)
} // End File


// Implements a function to replace the PHP "print" "function"
function print (str) {
	if ($debugging == 1)
		return
	else {
		str = "" + str + "";	//  Make sure that the m variable is a string.
		if ("undefined" != str)	//  Test for empty write or other undefined item.
			document.write(str);
	}
} // End Print

//					END PHP SIMULATION
//******************************************************************


//******************************************************************
//      THE SEARCH FUNCTION (ORIGINAL PHP SCRIPT - MAIN FUNCTION)

//FUNCTION Search
function search (sw) {
	// File templates used in search Function 
	var $template = new Array();
	var $urls = new Array();
	var $titles = new Array();
	var $descriptions = new Array();
	var $data = new Array();
	// Results Matrix. This is the original PHP Matrix $output (0..2,0..N-1)
	//@@ Each cell will be created dinamicaly as an array of 3 cells
	var $output = new Array();
	// File and Stream variables
	var FSystem, KeywordsFile, KeywordsStream;
	var $SearchWords = new Array();
	var $searchword, str, n;


	//@@@ Inizializations	
	$searchword = new String(sw); 
	str = new String (" ");

	//Split search phrase into words
	if ($WordSplit == 1)
		$SearchWords = $searchword.split(/[-_ +]/);
	else
		$SearchWords = $searchword.split(/[ ]/);
	
	//Open and print start of result page template
	$template = file ("search.htm")
	$numtlines = $template.length;	//Number of lines in the template
	$line = 0;
	while ($template[$line] != "<!--ZOOMSEARCH-->" && $line < $numtlines) {
		print ($template[$line]);
		$line++;
	} // End While
	$line++;	//Replace the key text <!--ZOOMSEARCH--> with the search result

	// Load the entire pages file into an array, all URL's on the site
	$urls = file ('pages.dat');
	// Load the entire page titles file into an array
	$titles = file ('titles.dat');
	if ($OutputStyle == 1)
		$descriptions = file ('descriptions.dat');

	//Print heading
	print ("<h2>Vsledky hledn \"" + $searchword + "\"</h2>\n");

	// Assign and open file keywords.dat
    FSystem = new ActiveXObject("Scripting.FileSystemObject");
    filename = $ProgramPath + "\\keywords.dat";
    KeywordsFile = FSystem.GetFile(filename);

	//Loop through all search words
	$numwords = $SearchWords.length;
	$outputline = 0;
	for ($sw = 0; $sw < $numwords; $sw++) {
		// Open the keywords file
	    KeywordsStream = KeywordsFile.OpenAsTextStream(ForReading,TristateUseDefault);
		//Read in a line at a time from the keywords files
		while (!KeywordsStream.AtEndOfStream) {
   			str = KeywordsStream.ReadLine ();
   			// Split the line into an array (split words using ',')
   			$data = str.split (",");
			if ($data[0] == $SearchWords[$sw]) {
				//Keyword found, so include it in the output list
				$num = $data.length;
				for ($kw=1; $kw < $num; $kw +=2) {
					//Check if page is already in output list
					$pageexists = 0;
					$ipage = $data[$kw]*1;
					//@@@ Improve eficiency. Stop loop when word is found
					$ol = 0;
					while (($pageexists == 0) && ($ol < $outputline))
						if ($output[$ol][0] == $ipage)
							$pageexists = 1
						else
							++$ol;
					if ($pageexists == 1) {
						//Page is already in output list, so add to count + extra
						$output[$ol][1] += $data[$kw+1]*1;	//Add in score
						$output[$ol][1] *= 2;				//Double Score as we have two words matching
						$output[$ol][2] += 1;				//Increase word match count
					}
					else {
						//@@ create matrix now
						$output[$outputline] = new Array (0,0,0);
						//New page to add to list
						$output[$outputline][0] = $ipage;			//Page index
						$output[$outputline][1] = $data[$kw+1]*1;	//Score
						$output[$outputline][2] = 1;	//Single word match only so far
						$outputline++;	
					} // End If
			    } // End For
			    break;	//This search word was found, so skip to next
			 } // End If	
		} // End While
		//Return to start of file
		KeywordsStream.Close();
	} // End For

	//Get number of pages matched
	$matches = $outputline;

	//Sort results in order of score, use the "SortCompare" function
	if ($matches > 1)
		$output.sort(SortCompare);

	//Count number of output lines that match ALL search terms
	$oline = 0;
	$fullmatches = 0;
	while (($oline < $matches) && ($numwords > 1)) {
		if ($output[$oline][2] == $numwords)
			$fullmatches++;
		$oline++;
	} // End While

	$SomeTermMatches = $matches - $fullmatches;

	var i;
	//Display search results
// print ("<div class=\"ram\"><p>");
// print ("<p>Probh testovn nov funkcionality. Omluvte obasn vpadky nebo podivn texty.<br>");
// print ($sw + "<br>" + $SearchWords[0]);
// print ("</p></div>");
	if ($matches == 1)
		print ("<p><em>1 nalezen zznam</em></p>\n")
	else if ($matches == 0)
		print ("<p>Nenalezeno.</p>\n")
	else if ($numwords > 1 && $JoinType == 0)	//OR
		print ("<p>" + $fullmatches + " strnek, kter obsahuj vechny hledan vrazy.<br>" + $SomeTermMatches + " strnek obsahujc nkter z hledanch vraz.</p>\n")
	else if ($numwords > 1 && $JoinType == 1)	//AND
		print ("<p>" + $fullmatches + " strnek, kter obsahuj vechny hledan vrazy.</p>\n")
	else
		print ("<p>" + $matches + " nalezench.</p>\n");

	print ("<div class=\"dotx\"></div>\n");
	//Output result
	$arrayline = 0;
	$oline = 0;
	while ($arrayline < $matches) {
		if (($JoinType == 1) && ($numwords > 1) && ($output[$arrayline][2] < $numwords)) {
			$arrayline++;
			continue;	//Boolean AND set && multiple search terms used && not all terms matched
		} // End If
		$ipage = $output[$oline][0];
		$score = $output[$oline][1];

// XXX Vybarven podkladu nalezenho vrazu
for ($ii = 0; $ii < $sw; $ii++) {
//	print ($SearchWords[$ii] + "<br>");
	$titles[$ipage] = replace($titles[$ipage],$SearchWords[$ii],"<span class=\"y\">" + $SearchWords[$ii] + "</span>");
	$descriptions[$ipage] = replace($descriptions[$ipage],$SearchWords[$ii],"<span class=\"y\">" + $SearchWords[$ii] + "</span>");
} // Next

		if ($OutputStyle == 0) {
			//Basic style
			print ("<p>" + "Strnka: <a href=" + $ProgramPath + $urls[$ipage] + ">" + $titles[$ipage] + "</a><br>\n");
			print ("Skre: " + $score + "&nbsp;&nbsp;<small><em>URL: <a href=" + $ProgramPath + $urls[$ipage] + ">" + $ProgramPath + $urls[$ipage] + "</a></em></small></p>\n");
		}
		else {
			//Descriptive style
			$PageMatch = $oline + 1;
			// print ("<p style=\"margin-top:1.5em\"><strong>" + $PageMatch + "&nbsp;<a href=\"" + $ProgramPath + $urls[$ipage] + "\">" + $titles[$ipage] + "</a></strong></p>\n");
			// print ("<p style=\"font-size:120%; margin:1.4em 0 0.2em 0\">" + $PageMatch + "&nbsp;<a href=\"" + $ProgramPath + $urls[$ipage] + "\">" + $titles[$ipage] + "</a></p>\n");
			print ("<p style=\"font-size:120%; margin:1.4em 0 0.2em 0\"><a href=\"" + $ProgramPath + $urls[$ipage] + "\">" + $titles[$ipage] + "</a></p>\n");
			print ("<p style=\"margin-bottom:0.2em; margin-top:0.2em\">&hellip;" + $descriptions[$ipage] + "&hellip;</p>\n");
			// print ("<p style=\"color:#008000; margin-top:0\">Nalezeno vraz:&nbsp;<strong>" + $output[$oline][2] + "</strong> Skre:&nbsp;<strong>" + $score + "</strong> URL:&nbsp;<a href=" + $ProgramPath + $urls[$ipage] + ">" + $ProgramPath + $urls[$ipage] + "</a></p>\n");
			print ("<p style=\"color:#008000; margin-top:0\">Nalezeno vraz:&nbsp;<strong>" + $output[$oline][2] + "</strong> | skre:&nbsp;<strong>" + $score + "</strong> | " + $ProgramPath + $urls[$ipage] + "</p>\n");
		} // End If
		$oline++;
		$arrayline++;
	} // End While

	//Let others know about Zoom.
	if ($ZoomInfo == 1) {
//		print ("<br><br><p><small><b><center>Search results generated by the <a href=http://www.wrensoft.com/zoom.htm>Zoom search engine</a></center></b></small></p>");

		//@@@ Two lines added - Zoom info translation 
//		print ("<Font color=Gray><small><center>Translated from Server-Side Script (PHP) to Client-Side Script (Jscript)<br>");
//		print ("by <a href=mailto:juanhdv@hotmail.com>Juan Gabriel Mejia</a> from Hijos de la Divina Voluntad - Colombia 2002.</center></small></Font>");
	}

	//Print out the end of the template
	while ($line < $numtlines) {
		print ($template[$line]);
		$line++;
	} // End While


//*****************************************************************
//               NOT YET IMPLEMENTED (FOR FUTURE RELEASES)
//	(** NO JSCRIPT SYNTAX - Original PHP Language Syntax follow **)
//
//Log the search words, if required
//	if ($Logging == 1) {
//		var theMoment = new Date();
//		
//		$LogString = Date("d-m-y H:i:s ") . $REMOTE_ADDR . " \"" .$searchword  . "\"" . ", Matches = " . $matches . "\n";
//		$fp = fopen ($LogFileName, "a");
//		if ($fp != false) {
//			fputs ($fp, $LogString);
//			fclose ($fp);
//		} // End If
//	} 
//******************************************************************
} // End Search()


// do_search: Manages the invotation to the Main Function Search
function do_search() {
	var sw;
	
	sw = new String (document.formsearch.searchword.value);
	if (sw != "undefined") {
		if (sw.length != 0) {
			document.open();
			//The Search is not case sentive, so....
			search(sw.toLowerCase()); // keywords file have all keywords in lowercase 
			document.close();
		} // End if
	} // End if
} //End do_search

function replace(string,text,by) {
// Replaces text with by in string
    var strLength = string.length, txtLength = text.length;
	// XXX
	var tempstring = string.toLowerCase();

    if ((strLength == 0) || (txtLength == 0)) return string;

	// XXX (msto tempstring byl string)
    var i = tempstring.indexOf(text);

    if ((!i) && (text != tempstring.substring(0,txtLength))) return string;
    if (i == -1) return string;

    var newstr = string.substring(0,i) + by;

    if (i+txtLength < strLength)
        newstr += replace(string.substring(i+txtLength,strLength),text,by);

    return newstr;
}


-->
